(*fonction d'affichage d'un graphe  l'aide des coordonnes pralablement calcules*)
(*ocamlmktop -custom -o myocaml unix.cma graphics.cma -cclib -lgraphics -cclib -lX11 *)

open Graphics;;
open Structures;;

let draw_node n x y fil =
  let (w,h) = text_size (string_of_int n)
  in let r = int_of_float (ceil ((sqrt (((float_of_int w) /. 2.) ** 2. +.
					  ((float_of_int h) /. 2.) ** 2.)) +. 1.))
  in 
    set_color fil;
    fill_circle x y r;
    set_color foreground;
    moveto (x - w / 2 + 1) (y - h / 2);
    draw_string (string_of_int n);
    draw_circle x y r;;
 

let affiche graph tab_posit tab_color=
  let n = get_n graph 
  and d = get_d graph 
  (*and mat = get_matrice graph *)
  and next_pt= ref (0,0)
  and current_pos = ref (0,0) in
    for i=0 to (n-1) do (*trace les artes*)
      begin
	current_pos :=  tab_posit.(i);
	for j=0 to (d-1) do
	  if (i_eme_voisin graph i j) > i then
	    begin
	      next_pt := tab_posit.(i_eme_voisin graph i j);
	      moveto (fst !current_pos) (snd !current_pos) ;
	      lineto (fst !next_pt) (snd !next_pt)
	    end;
	done;
      end;
    done;
    for i=0 to (n-1) do (*trac des noeuds*)
      draw_node i (fst tab_posit.(i)) (snd tab_posit.(i)) tab_color.(i);
    done ;;






