/* Gestion des nombres complexes */

#include <math.h>

#include "complex.h"

/* z1 <- z1 + z2 */
void cc_add (cplx_t *z1, cplx_t *z2)
{
  z1->re += z2->re;
  z1->im += z2->im;
}

/* z1 <- z1 - z2 */
void cc_sub (cplx_t *z1, cplx_t *z2)
{
  z1->re -= z2->re;
  z1->im -= z2->im;
}

/* z <- z * r */
void cr_mul (cplx_t *z, double x)
{
  z->re *= x;
  z->im *= x;
}

/* |z| */
double c_norm (cplx_t *z)
{
  return sqrt (z->re * z->re + z->im * z->im);
}

/* z <- k-eme racine n-eme de 1 */
void ni_root (cplx_t *z, int n, int k)
{
  z->re = cos (2.0 * k * M_PI / n); 
  z->im = sin (2.0 * k * M_PI / n); 
}
