#include <stdio.h>
#include <stdarg.h>

#include "debug.h"

static int debug_level = 0;
static int debug_indent = 0;

void set_debug_level (int level)
{
  debug_level = level;
  debug_indent = 0;
}

void reset_debug (void)
{
  debug_indent = 0;
}

void debug_in (int level, const char *format, ...)
{
  int i;
  va_list ap;

  if (level > debug_level) return;

  for (i = 0; i < debug_indent; i++)
    fprintf (stderr, "   ");

  va_start (ap, format);
  vfprintf (stderr, format, ap);
  va_end (ap);
  fprintf (stderr, "\n");
  debug_indent++;
}

void debug_out (int level, const char *format, ...)
{
  int i;
  va_list ap;

  if (level > debug_level) return;

  debug_indent--;

  for (i = 0; i < debug_indent; i++)
    fprintf (stderr, "   ");

  va_start (ap, format);
  vfprintf (stderr, format, ap);
  va_end (ap);
  fprintf (stderr, "\n");
}
